<ng-container *ngIf="subject else loading_screen">
  <section class="content-header">
    <h1 class="page-head-line">
      Subject |
      <small>
        {{ subject.subject.subject_name }}
      </small>
    </h1>
  </section>

  <section class="content">
    <div class="container-fluid mx-0">
      <div class="row">

        <div class="col-lg-3 pl-0">

          <div class="box box-primary rounded-0">

            <div class="box-body">
              <strong>
                <i class="fa fa-file-text-o margin-r-5"></i>
                Examinations
              </strong>
              <p>
                <span *ngIf="getQEHLength(exams,QEH_status.Ongoing)" class="label label-danger">
                  {{ getQEHLength(exams,QEH_status.Ongoing) }} ongoing
                </span>
                <span *ngIf="getQEHLength(exams,QEH_status.Done)" class="label label-success">
                  {{ getQEHLength(exams,QEH_status.Done) }} finished
                </span>
              </p>

              <ul class="list-group list-group-unbordered">
                <li class="list-group-item border-top-0">
                  Published <a class="pull-right">{{ getQEHLength(exams,QEH_status.Published) }}</a>
                </li>
                <li class="list-group-item">
                  Unpublished <a class="pull-right">{{ getQEHLength(exams,QEH_status.Unpublished) }}</a>
                </li>
                <li class="list-group-item border-bottom-0">
                  <b>Total</b> <a class="pull-right">{{ exams.length }}</a>
                </li>
              </ul>
            </div>
          </div>

          <div class="box box-success rounded-0">

            <div class="box-body">
              <strong>
                <i class="fa fa-file margin-r-5"></i>
                Quizzes
              </strong>
              <p>
                <span *ngIf="getQEHLength(quizzes,QEH_status.Ongoing)" class="label label-danger">
                  {{ getQEHLength(quizzes,QEH_status.Ongoing) }} ongoing
                </span>
                <span *ngIf="getQEHLength(quizzes,QEH_status.Done)" class="label label-success">
                  {{ getQEHLength(quizzes,QEH_status.Done) }} finished
                </span>
              </p>

              <ul class="list-group list-group-unbordered">
                <li class="list-group-item border-top-0">
                  Published <a class="pull-right">{{ getQEHLength(quizzes,QEH_status.Published) }}</a>
                </li>
                <li class="list-group-item">
                  Unpublished <a class="pull-right">{{ getQEHLength(quizzes,QEH_status.Unpublished) }}</a>
                </li>
                <li class="list-group-item border-bottom-0">
                  <b>Total</b> <a class="pull-right">{{ quizzes.length }}</a>
                </li>
              </ul>
            </div>
          </div>

          <div class="box box-warning rounded-0">

            <div class="box-body">
              <strong>
                <i class="fa fa-file-archive-o margin-r-5"></i>
                Homeworks
              </strong>
              <p>
                <span *ngIf="getQEHLength(homeworks,QEH_status.Ongoing)" class="label label-danger">
                  {{ getQEHLength(homeworks,QEH_status.Ongoing) }} ongoing
                </span>
                <span *ngIf="getQEHLength(homeworks,QEH_status.Done)" class="label label-success">
                  {{ getQEHLength(homeworks,QEH_status.Done) }} finished
                </span>
              </p>

              <ul class="list-group list-group-unbordered">
                <li class="list-group-item border-top-0">
                  Published <a class="pull-right">{{ getQEHLength(homeworks,QEH_status.Published) }}</a>
                </li>
                <li class="list-group-item">
                  Unpublished <a class="pull-right">{{ getQEHLength(homeworks,QEH_status.Unpublished) }}</a>
                </li>
                <li class="list-group-item border-bottom-0">
                  <b>Total</b> <a class="pull-right">{{ homeworks.length }}</a>
                </li>
              </ul>
            </div>
          </div>

          <div class="box box-default rounded-0">
            <div class="box-body">
              <strong>
                <i class="fa fa-file-bicycle margin-r-5"></i>
                Excercises
              </strong>
              <p>
                <span *ngIf="getQEHLength(exercises,QEH_status.Ongoing)" class="label label-danger">
                  {{ getQEHLength(exercises,QEH_status.Ongoing) }} ongoing
                </span>
                <span *ngIf="getQEHLength(exercises,QEH_status.Done)" class="label label-success">
                  {{ getQEHLength(exercises,QEH_status.Done) }} finished
                </span>
              </p>

              <ul class="list-group list-group-unbordered">
                <li class="list-group-item border-top-0">
                  Published <a class="pull-right">{{ getQEHLength(exercises,QEH_status.Published) }}</a>
                </li>
                <li class="list-group-item">
                  Unpublished <a class="pull-right">{{ getQEHLength(exercises,QEH_status.Unpublished) }}</a>
                </li>
                <li class="list-group-item border-bottom-0">
                  <b>Total</b> <a class="pull-right">{{ exercises.length }}</a>
                </li>
              </ul>
            </div>
          </div>

        </div>

        <div class="col-lg-9">
          <div class="row">

            <div class="col-lg-4 col-md-6 col-sm-6 p-0">
              <input type='text' name="search" [(ngModel)]="search" (keyup)='updateFilter()' class="form-control form-control-sm mb-0"
                placeholder='Seach here' />
            </div>
            <div class="col-lg-8 col-md-6 pr-0">
              <div class="float-right mb-4">
                <div class="btn-group">
                  <a routerLink="/teacher/qeh/add/{{ subject.id }}" class="btn mr-1 bk-clr-three btn-sm btn-flat">
                    <span class="fa fa-plus"></span>
                    Add
                  </a>
                  <button type="button" class="btn  bk-clr-three btn-sm btn-flat">
                    <span class="fa fa-file-excel-o"></span>
                    Download as excel
                  </button>
                </div>
              </div>
            </div>
            <div class="col-12 col-lg-12 p-0">

              <ngx-datatable #tblSubject class="material mb-4" [rows]="QEHs" [loadingIndicator]="loading" [columnMode]="'force'" [headerHeight]="45"
                [footerHeight]="40" [rowHeight]="'auto'" [limit]="15">

                <ngx-datatable-column [width]="90" prop="qeh_code" name="QEH code" [headerClass]="'pl-3'">
                  <ng-template let-row="row" ngx-datatable-cell-template>
                    <a href="#" class="pl-2" routerLink="/teacher/qeh/{{ row.id }}/questions">{{ row.qeh_code }}</a>
                  </ng-template>
                </ngx-datatable-column>
                <ngx-datatable-column [width]="100" prop="qeh_type_str" name="Type"></ngx-datatable-column>
                <ngx-datatable-column [width]="160" prop="release_time" name="Release date">
                  <ng-template let-row="row" ngx-datatable-cell-template>
                    {{ row.release_date | date:'MM/dd/yyyy' }} @ {{ row.release_time }}
                  </ng-template>
                </ngx-datatable-column>
                <ngx-datatable-column [width]="160" prop="end_time" name="End date">
                  <ng-template let-row="row" ngx-datatable-cell-template>
                    {{ row.end_date | date:'MM/dd/yyyy' }} @ {{ row.end_time }}
                  </ng-template>
                </ngx-datatable-column>

                <ngx-datatable-column [width]="100" prop="status" name="Status"></ngx-datatable-column>
                <ngx-datatable-column name="Action" [headerClass]="'text-center'" [cellClass]="'text-center'">
                  <ng-template let-row="row" ngx-datatable-cell-template>
                    <a href="#" routerLink="/teacher/qeh/{{ row.id }}/questions" class="text-info pr-2" title="view questions">
                      <span class="fa fa-file-o"></span>
                    </a>
                    <ng-container *ngIf="!row.published">
                      <a href="#" routerLink="/teacher/qeh/edit/{{ subject.id }}" [queryParams]="{ref: row.id}" class="text-green pl-lg-1 pr-2"
                        title="edit">
                        <span class="fa fa-edit"></span>
                      </a>
                      <button type="button" (click)="open(content,row)" class="pr-2 btn btn-link btn-sm text-primary" title="publish">
                        <span class="fa fa-cloud-upload"></span>
                      </button>
                      <button type="button" class="ml-auto btn btn-link btn-sm text-white" placement="left" (click)="setQEH(row)" [ngbPopover]="popDeleteContent"
                        [popoverTitle]="popDeleteTitle" container="body" [autoClose]="'outside'" #deletePop="ngbPopover">
                        <span class="fa fa-trash text-red"></span>
                      </button>
                    </ng-container>

                  </ng-template>
                </ngx-datatable-column>

              </ngx-datatable>
            </div>

          </div>
        </div>

      </div>
    </div>
  </section>
</ng-container>

<ng-template #popDeleteTitle>
  <small>
    <b>
      Confirm delete
    </b>
  </small>
</ng-template>

<ng-template #popDeleteContent>

  <p>Are you sure you want to delete this QEH?</p>
  <p class="small">
    <strong>QEH Code: </strong>{{ obj.qeh_code}}
  </p>

  <div class="d-flex my-2">
    <div class="ml-auto">

      <button (click)="delete()" type="button" class="btn btn-link px-2" data-toggle="tooltip" data-placement="bottom" title="Yes">
        <span class="fa fa-check text-green"></span>
      </button>
    </div>

  </div>
</ng-template>

<ng-template #content let-close="close">
  <form *ngIf="obj" #objForm=ngForm (ngSubmit)="publish()" class="mb-0">
    <div class="modal-header border-bottom-0">
      <p>
        <strong>
          Publish |
          <small>{{ obj?.qeh_code }}</small>
        </strong>
      </p>
      <button type="button" class="btn btn-link text-secondary" aria-label="Close" (click)="dismiss()">
        <span class="fa fa-times"></span>
      </button>
    </div>
    <div class="modal-body">
      <div class="form-row justify-content-center">

        <div class="col-md-6 p-0 mb-4">
          <label for="release_date" class="control-label mb-1"><small>Release date</small></label>
          <input type="text" [(ngModel)]="obj.release_date" name="release_date" class="form-control form-control-sm" [bsConfig]="bsConfig"
            bsDatepicker placeholder="MM/DD/YYYY" required>
          <span class="text-danger" [hidden]="!error.release_date">{{ error.release_date }}</span>
        </div>

        <div class="col-md-4 mb-4">
          <label for="release_time" class="control-label mb-1"><small>Release time</small></label>
          <input [(ngModel)]="obj.release_time" name="release_time" [ngxTimepicker]="release_picker" type="text" class="form-control form-control-sm"
            placeholder="Release time">
          <span class="text-danger" [hidden]="!error.release_time">{{ error.release_time }}</span>
          <ngx-material-timepicker #release_picker></ngx-material-timepicker>
        </div>

        <div class="col-md-6 p-0 mb-4">
          <label for="end_date" class="control-label mb-1"><small>End date</small></label>
          <input type="text" [(ngModel)]="obj.end_date" name="end_date" class="form-control form-control-sm" [bsConfig]="bsConfig"
            bsDatepicker placeholder="MM/DD/YYYY" required>
          <span class="text-danger" [hidden]="!error.end_date">{{ error.end_date }}</span>
        </div>

        <div class="col-md-4 mb-4">
          <label for="end_time" class="control-label mb-1"><small>End time</small></label>
          <input [(ngModel)]="obj.end_time" name="end_time" [ngxTimepicker]="end_picker" type="text" class="form-control form-control-sm"
            placeholder="End time">
          <span class="text-danger" [hidden]="!error.end_time">{{ error.end_time }}</span>
          <ngx-material-timepicker #end_picker></ngx-material-timepicker>
        </div>

      </div>
    </div>
    <div class="modal-footer">
      <div class="form-group float-right mt-2 mb-1">
        <button type="submit" [disabled]="!objForm.valid" class="btn btn-primary btn-flat btn-sm py-1 small">
          <span class="fa fa-save"></span>
          Publish
        </button>
        <button type="button" (click)="dismiss()" class="btn btn-danger btn-flat btn-sm py-1 small">
          <span class="fa fa-times"></span>
          Cancel
        </button>
      </div>
    </div>
  </form>
</ng-template>


<ng-template #loading_screen>
  <app-loading></app-loading>
</ng-template>